CREATE TABLE repo
  ( name TEXT    NOT NULL
  , id   INTEGER NOT NULL
  );

CREATE TABLE repo_kara
  ( repo_id       INTEGER NOT NULL REFERENCES repo(id)
  , repo_kara_id  INTEGER NOT NULL
  , local_kara_id INTEGER NOT NULL REFERENCES kara(id)
  , PRIMARY KEY (repo_id, repo_kara_id, local_kara_id)
  );

CREATE TABLE kara
  ( id          INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT
  , is_dl       BOOLEAN NOT NULL DEFAULT false
  , song_title  TEXT    NOT NULL
  , song_type   TEXT    NOT NULL
  , song_origin TEXT    NOT NULL
  , source_name TEXT    NOT NULL
  , language    TEXT    NOT NULL
  , kara_hash   TEXT    NOT NULL -- TEXT ABOVE + HASH OF FILE IN FS
  );

CREATE TABLE kara_makers
  ( id   INTEGER NOT NULL REFERENCES kara ON DELETE CASCADE
  , name TEXT    NOT NULL
  , PRIMARY KEY (id, name)
  );

CREATE TABLE tag
  ( id   INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT
  , name TEXT    NOT NULL
  );

CREATE TABLE kara_tags
  ( kara_id INTEGER NOT NULL REFERENCES kara(id) ON DELETE CASCADE
  , tag_id  INTEGER NOT NULL REFERENCES tag(id)  ON DELETE CASCADE
  , value   TEXT
  , PRIMARY KEY (kara_id, tag_id, value)
  );

CREATE TABLE queue_1
  ( id       INTEGER NOT NULL REFERENCES kara(id) ON DELETE CASCADE
  , position INTEGER NOT NULL CHECK(position > 0)
  );

CREATE TABLE history
  ( id      INTEGER NOT NULL REFERENCES kara(id) ON DELETE CASCADE
  , epoch   INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT
  , PRIMARY KEY (id, epoch)
  );
